SystemOrganization addCategory: #'Magritte-Morph-Core'!

!MAContainer class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 4/25/2005 13:40'!
defaultMorphClasses
	^ Array with: MAContainerMorph.! !

Object subclass: #MADescriptionMorph
	instanceVariableNames: 'wrapper morph answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

MADescriptionMorph subclass: #MAContainerMorph
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MAContainerMorph methodsFor: 'private' stamp: 'lr 4/25/2005 13:46'!
buildChildren
	^ Array streamContents: [ :stream |
		self description do: [ :each |
			each isVisible ifTrue: [
				stream nextPut: (each 
					asMorphOn: self value) ] ] ].! !

!MAContainerMorph methodsFor: 'accessing' stamp: 'lr 4/25/2005 17:32'!
children
	^ children ifNil: [ children := self buildChildren ].! !

!MAContainerMorph methodsFor: 'actions' stamp: 'lr 4/25/2005 13:29'!
commit
	self children do: [ :each | each commit ].! !

!MAContainerMorph methodsFor: 'actions' stamp: 'lr 4/25/2005 13:29'!
reset
	self children do: [ :each | each reset ].! !

!MAContainerMorph methodsFor: 'actions' stamp: 'lr 4/25/2005 13:29'!
validate
	self children do: [ :each | each validate ].! !

!MAContainerMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 20:52'!
viewerMorph
	| container |
	container := self rectangleMorph
		setBalloonText: self description comment;
		cellInset: 3;
		listDirection: #topToBottom;
		yourself.
	self children do: [ :each |
		container addMorphBack: each morph ].
	^ container.! !

!MADescriptionMorph class methodsFor: 'instance creation' stamp: 'lr 4/25/2005 13:16'!
model: aModel
	^ self model: aModel description: aModel description.! !

!MADescriptionMorph class methodsFor: 'instance creation' stamp: 'lr 4/25/2005 13:16'!
model: aModel description: aDescription
	^ self wrapper: (aModel defaultWrapperClass on: aDescription model: aModel).! !

!MADescriptionMorph class methodsFor: 'instance creation' stamp: 'lr 4/25/2005 13:24'!
wrapper: aWrapper
	^ self new
		setWrapper: aWrapper;
		yourself.! !

!MADescriptionMorph methodsFor: 'actions-conveniance' stamp: 'lr 4/25/2005 21:43'!
accept
	[ self validate ] 
		on: Error
		do: [ :err | ^ self inform: err messageText ].
	self commit; answer: self value.! !

!MADescriptionMorph methodsFor: 'adding' stamp: 'lr 4/25/2005 20:49'!
addButtons
	self addButtons: #( accept cancel ).! !

!MADescriptionMorph methodsFor: 'adding' stamp: 'lr 4/25/2005 20:53'!
addButtons: anArray
	morph := self rectangleMorph
		listDirection: #topToBottom;
		addMorphBack: self morph;
		addMorphBack: (self barMorph: anArray);
		yourself.! !

!MADescriptionMorph methodsFor: 'adding' stamp: 'lr 4/25/2005 21:25'!
addWindow
	self morph layoutInset: 5@5.
	morph := self windowMorph
		model: self;
		vResizing: #shrinkWrap;
		
		addMorph: self morph frame: (0 @ 0 corner: 1 @ 1);
		yourself.! !

!MADescriptionMorph methodsFor: 'answering' stamp: 'lr 4/25/2005 20:24'!
answer: anObject
	answer isNil
		ifFalse: [ answer value: anObject ].
	self morph delete.! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 4/25/2005 21:52'!
arrowKey: aCharacter from: aMorph
! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 4/25/2005 21:11'!
barMorph: anArray
	| bar |
	bar := self rectangleMorph
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		listDirection: #leftToRight;
		listCentering: #center;
		wrapCentering: #bottomRight;
		cellInset: self defaultSpacerSize;
		yourself.
	anArray do: [ :selector |
		bar addMorphBack: (self buttonMorph: selector) ].
	^ bar.! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 4/25/2005 20:47'!
buttonMorph: aSelector
	| button |
	button := PluggableButtonMorph
		on: self 
		getState: #buttonState 
		action: aSelector.
	button
		label: aSelector;
		shortcutCharacter: aSelector first;
		onColor: Color transparent offColor: Color white;
		useRoundedCorners;
		borderWidth: 2;
		borderColor: #raised.
	^ button.! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 4/25/2005 19:32'!
buttonState
	^ true! !

!MADescriptionMorph methodsFor: 'actions-conveniance' stamp: 'lr 4/25/2005 20:19'!
cancel
	self answer: nil.! !

!MADescriptionMorph methodsFor: 'actions-conveniance' stamp: 'lr 4/25/2005 20:48'!
close
	self cancel.! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 4/25/2005 13:26'!
commit
	self description isReadonly
		ifFalse: [ self wrapper commit ].! !

!MADescriptionMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 18:33'!
composedMorph
	^ self editorMorph.! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 4/25/2005 13:24'!
container
	^ self hasParentComponent
		ifTrue: [ self parent ]
		ifFalse: [ self ].! !

!MADescriptionMorph methodsFor: 'accessing-configuration' stamp: 'lr 4/25/2005 20:38'!
defaultBackgroundColor
	^ self description morphColor.! !

!MADescriptionMorph methodsFor: 'accessing-configuration' stamp: 'lr 4/25/2005 21:02'!
defaultSpacerSize
	^ 5! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 4/25/2005 13:25'!
description
	^ self wrapper owner.! !

!MADescriptionMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 17:29'!
editorMorph
	^ self viewerMorph.! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 4/25/2005 13:25'!
model
	^ self wrapper model.! !

!MADescriptionMorph methodsFor: 'accessing-dynamic' stamp: 'lr 4/25/2005 18:32'!
morph
	^ morph ifNil: [ morph := self composedMorph ].! !

!MADescriptionMorph methodsFor: 'answering' stamp: 'lr 4/25/2005 20:20'!
onAnswer: aBlock
	answer := aBlock! !

!MADescriptionMorph methodsFor: 'opening' stamp: 'lr 4/25/2005 13:32'!
openInHand
	^ self morph openInHand.
! !

!MADescriptionMorph methodsFor: 'opening' stamp: 'lr 4/25/2005 13:49'!
openInWorld
	^ self morph openInWorld.! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'lr 4/25/2005 13:24'!
parent
	^ parent! !

!MADescriptionMorph methodsFor: 'private' stamp: 'lr 4/25/2005 21:35'!
perform: selector orSendTo: otherTarget
	^ (self respondsTo: selector)
		ifTrue: [ self perform: selector ]
		ifFalse: [ otherTarget perform: selector ].! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 4/25/2005 21:04'!
rectangleMorph
	^ RectangleMorph new
		borderWidth: 0;
		color: Color transparent;
		layoutPolicy: TableLayout new;
		cellPositioning: #topLeft;
		vResizing: #shrinkWrap;
		hResizing: #spaceFill;
		yourself.! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 4/25/2005 13:26'!
reset
	self wrapper reset.! !

!MADescriptionMorph methodsFor: 'actions-conveniance' stamp: 'lr 4/25/2005 20:48'!
save
	self accept.! !

!MADescriptionMorph methodsFor: 'initialization' stamp: 'lr 4/25/2005 13:26'!
setParent: aComponent
	parent := aComponent! !

!MADescriptionMorph methodsFor: 'initialization' stamp: 'lr 4/25/2005 13:26'!
setWrapper: aWrapper
	wrapper := aWrapper! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 4/25/2005 20:39'!
stringMorph
	^ StringMorph new.! !

!MADescriptionMorph methodsFor: 'actions' stamp: 'lr 4/25/2005 13:26'!
validate
	self wrapper validate.! !

!MADescriptionMorph methodsFor: 'accessing-wrapper' stamp: 'lr 4/25/2005 13:25'!
value
	^ self wrapper value.! !

!MADescriptionMorph methodsFor: 'accessing-wrapper' stamp: 'lr 4/25/2005 13:25'!
value: anObject
	self wrapper value: anObject.! !

!MADescriptionMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 17:29'!
viewerMorph
	^ self stringMorph
		contents: self value asLabel;
		yourself.! !

!MADescriptionMorph methodsFor: 'prototypes' stamp: 'lr 4/25/2005 20:33'!
windowMorph
	^ SystemWindow labelled: self description label.! !

!MADescriptionMorph methodsFor: 'accessing' stamp: 'lr 4/25/2005 13:24'!
wrapper
	^ wrapper! !

MADescriptionMorph subclass: #MAElementMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MAElementMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 19:19'!
composedMorph
	| composed |
	composed := self rectangleMorph
		layoutInset: 1 @ 1;
		listDirection: #leftToRight;
		setBalloonText: self description comment;
		addMorphBack: self labelMorph;
		addMorphBack: (self description isReadonly
			ifTrue: [ self viewerMorph ]
			ifFalse: [ self editorMorph ]);
		yourself.
	self description isRequired
		ifTrue: [ composed addMorphBack: self requiredMorph ].
	^ composed.! !

!MAElementMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 18:26'!
labelMorph
	^ self stringMorph
		contents: self description label , ':';
		width: 100;
		yourself.! !

!MAElementMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 18:26'!
requiredMorph
	^ self stringMorph
		contents: ' *';
		color: Color red;
		yourself.! !

!MAElementMorph methodsFor: 'accessing' stamp: 'lr 4/25/2005 14:43'!
string
	^ self description toString: self value.! !

!MAElementMorph methodsFor: 'accessing' stamp: 'lr 4/25/2005 21:37'!
string: aString
	self value: (self description parseString: aString).
	self changed: #string.! !

MAElementMorph subclass: #MAListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MAListMorph methodsFor: 'accessing' stamp: 'lr 4/25/2005 17:25'!
options
	^ self description allOptions! !

MAListMorph subclass: #MAMultipleListMorph
	instanceVariableNames: 'primary'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MAMultipleListMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 21:05'!
editorMorph
	^ (PluggableListMorphOfMany
		on: self
		list: #options 
		primarySelection: #primary
		changePrimarySelection: #primary: 
		listSelection: #value
		changeListSelection: #value:
		menu: #menu)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 2;
		yourself.! !

!MAMultipleListMorph methodsFor: 'private' stamp: 'lr 4/25/2005 17:46'!
menu
	^ nil! !

!MAMultipleListMorph methodsFor: 'accessing' stamp: 'lr 4/25/2005 17:45'!
primary
	^ primary! !

!MAMultipleListMorph methodsFor: 'accessing' stamp: 'lr 4/25/2005 17:45'!
primary: anObject
	primary := anObject! !

MAListMorph subclass: #MASingleListMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MASingleListMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 21:05'!
editorMorph
	^ (PluggableListMorph on: self list: #options selected: #selected changeSelected: #selected:)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 2;
		yourself.! !

!MASingleListMorph methodsFor: 'accessing' stamp: 'lr 4/25/2005 17:48'!
selected
	^ self options indexOf: self value.! !

!MASingleListMorph methodsFor: 'accessing' stamp: 'lr 4/25/2005 19:05'!
selected: anInteger
	self value: (self options at: anInteger ifAbsent: nil).
	self changed: #selected.! !

MAElementMorph subclass: #MATextAreaMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MATextAreaMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 21:54'!
editorMorph
	^ (PluggableTextMorph on: self text: #string accept: #string:)
		hResizing: #spaceFill;
		borderColor: #inset;
		borderWidth: 2;
		yourself.! !

!MATextAreaMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 21:16'!
string: aString
	super string: aString.! !

!MATextAreaMorph methodsFor: 'actions' stamp: 'lr 4/25/2005 21:54'!
validate
	self morph allMorphsDo: [ :each | 
		(each respondsTo: #accept)
			ifTrue: [ each accept ] ].
	super validate.! !

MATextAreaMorph subclass: #MATextLineMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Morph-Core'!

!MATextLineMorph methodsFor: 'morphic' stamp: 'lr 4/25/2005 20:41'!
editorMorph
	^ super editorMorph
		hideScrollBarsIndefinitely: true;
		acceptOnCR: true;
		height: 20;
		yourself.! !

!Object methodsFor: '*Magritte-Morph-converting' stamp: 'lr 4/25/2005 13:17'!
asMorph
	^ self description asMorphOn: self.! !

!MAMultipleSelectionDescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 4/25/2005 17:27'!
defaultMorphClasses
	^ Array with: MAMultipleListMorph.! !

!MADescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 4/25/2005 13:21'!
defaultMorphClass
	^ self defaultMorphClasses first.! !

!MADescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 4/25/2005 13:22'!
defaultMorphClasses
	^ Array new.! !

!MADescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 4/25/2005 20:36'!
defaultMorphColor
	^ Color r: 0.151 g: 0.327 b: 0.720.! !

!MADescription class methodsFor: '*Magritte-Morph-description' stamp: 'lr 4/25/2005 13:22'!
descriptionMorphClass
	^ (MASingleSelectionDescription selector: #morphClass label: 'Morph Class' priority: 600)
		options: self defaultMorphClasses;
		beRequired;
		yourself.! !

!MADescription methodsFor: '*Magritte-Morph-converting' stamp: 'lr 4/25/2005 13:18'!
asMorphOn: anObject
	^ self morphClass model: anObject description: self.! !

!MADescription methodsFor: '*Magritte-Morph-accessing' stamp: 'lr 4/25/2005 13:19'!
morphClass
	^ self propertyAt: #morphClass ifAbsent: [ self class defaultMorphClass ].! !

!MADescription methodsFor: '*Magritte-Morph-accessing' stamp: 'lr 4/25/2005 13:20'!
morphClass: aClass
	^ self propertyAt: #morphClass put: aClass.! !

!MADescription methodsFor: '*Magritte-Morph-accessing' stamp: 'lr 4/25/2005 20:35'!
morphColor
	^ self propertyAt: #morphColor ifAbsent: [ self class defaultMorphColor ].! !

!MADescription methodsFor: '*Magritte-Morph-accessing' stamp: 'lr 4/25/2005 20:35'!
morphColor: aColor
	^ self propertyAt: #morphColor put: aColor.! !

!MATextDescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 4/25/2005 17:18'!
defaultMorphClasses
	^ Array with: MATextAreaMorph.! !

!MAStringDescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 4/25/2005 17:18'!
defaultMorphClasses
	^ Array with: MATextLineMorph.! !

!MASingleSelectionDescription class methodsFor: '*Magritte-Morph-defaults' stamp: 'lr 4/25/2005 17:27'!
defaultMorphClasses
	^ Array with: MASingleListMorph.! !
